<template>
  <div class="tab-carousel">
    <!-- titles for mobile adaptation -->
    <transition name="fade">
      <p class="tab-slide__title">{{ tabsTitle[currentSlideIndex] }}</p>
    </transition>
    <Carousel
      :breakpoints="breakpoints"
      :slideRatio="aspectRatio"
      :touchable="true"
      :dragging-distance="70"
      :slideImageInside="true"
      :bulletsOutside="true"
      :arrows="false"
      lazy
      lazy-load-on-drag
      class="no-shadow"
      @slide="showCurrentTab('slide', $event)"
    >
      <!-- tabs -->
      <template v-slot:bullet="{ active, index }">
        <p class="tab-slide__bullet" :class="{ active: active }">
          {{ tabsTitle[index - 1] }}
        </p>
      </template>

      <!-- slot for slides -->
      <slot />
    </Carousel>
    <ScrollAnimation
      class="tab-carousel__scroll-animation"
      v-show="scrollAnimation"
    />
  </div>
</template>

<script>
import { VueperSlides } from 'vueperslides'
import ScrollAnimation from '@/components/shared/ScrollAnimation'

export default {
  name: 'TabCarousel',
  data: () => ({
    currentSlideIndex: 0
  }),
  components: {
    Carousel: VueperSlides,
    ScrollAnimation
  },
  props: {
    tabsTitle: {
      type: Array,
      required: true
    },
    aspectRatio: {
      type: Number
    },
    breakpoints: {
      type: Object
    },
    scrollAnimation: {
      type: Boolean,
      default: () => false
    }
  },
  methods: {
    showCurrentTab(_, params) {
      this.currentSlideIndex = params.currentSlide.index
    }
  }
}
</script>
